// 引入標準程式庫中的 cstdlib 及 ctime
#include <cstdlib> // srand(), rand()
#include <ctime>   // time()
// 引入標準程式庫中的 iostream
#include <iostream> // cout, endl

// 引入 Encrypt 類別的標頭檔
#include "encrypt01.h"

// 使用 std 中的兩個名稱
using std::cout; // 標準輸出串流的物件
using std::endl; // 新行符號，等於 '\n'

// Encrypt 的建構函數
Encrypt::Encrypt() {
    // 呼叫 setter 設定 code_array
    set_code_array();
}

// 設定 code_array 的 setter 成員函數
void Encrypt::set_code_array() {
    // 初始化擬隨機數產生器
    srand(time(0));

    // 取得 a 、 b 值，其中 a 不等於 0 或偶數
    int a = 0;
    int b = 0;
    while (a % 2 == 0) {
        // rand() 回傳 0 到 RAND_MAX 之間的擬隨機整數
        a = rand() % 10;
        b = rand() % 10;
    }

    // 印出 a 、 b 值
    cout << a << ", ";
    cout << b << ", ";

    // 利用公式建立密碼表字串
    int x, y, m;
    char c = 'a';
    string s;
    int i;
    for (i = 0; i < 26; i++) {
        x = c;
        y = x * a + b;
        m = y % 26;
        s += m + 97;
        c++;
    }

    // 將建立好的密碼表直接設定給成員變數
    code_array = s;
}

// 回傳密碼表字串的 getter 成員函數
string Encrypt::get_code_array() {
    return code_array;
}

/* 《程式語言教學誌》的範例程式
   http://kaiching.org/
   檔名：encrypt04.cxx
   功能：實作發展中版本的 Encrypt 類別
   作者：張凱慶 */
