// 引入標準程式庫中的 iostream
#include <iostream>

// cout 為 std 中的輸出物件
using std::cout;
// endl 為 std 中的斷行符號
using std::endl;

// 引入 Encrypt 類別的標頭檔
#include "encrypt_refactor.h"

// 程式執行的 main() 函數
int main() {
    // 印出空白一行
    cout << endl;
    // 建立 Encrypt 物件
    Encrypt encryptor;
    // 印出密碼表字串
    cout << encryptor.get_code_array() << endl << endl;

    // 印出準備編碼的字串
    string d = "There is no spoon.";
    cout << d << endl;

    // 將字串編碼，然後印出編碼結果
    string r1 = encryptor.ToEncode(d);
    cout << r1 << endl << endl;

    // 重新解碼碼，然後印出解碼結果
    string r2 = encryptor.ToDecode(r1);
    cout << r2 << endl << endl;

    return 0;
}

/* 《程式語言教學誌》的範例程式
   http://kaiching.org/
   檔名：encrypt_refactor_demo.cxx
   功能：Encrypt 類別的標頭檔
   作者：張凱慶 */
