// 引入標準程式庫中相關的輸入、輸出程式
#include <iostream>

// std 為標準程式庫的命名空間
using namespace std;

// 宣告 Member 類別
class Member {
// 宣告 public 成員
public:
    Member(int, string);
    int get_id();
    string get_name();

private:
    int id;
    string name;
    void set_id(int);
    void set_name(string);
};

// 實作建構函數
Member::Member(int id, string name) {
    set_id(id);
    set_name(name);
}

// 實作 setter 成員函數
void Member::set_id(int n) {
    id = n;
}

void Member::set_name(string n) {
    name = n;
}

// 實作 getter 成員函數
int Member::get_id() {
    return id;
}

string Member::get_name() {
    return name;
}

int main(void) {
    // 宣告建立 Member 物件
    Member m(0, "Alice");

    // 印出 id 與 name
    cout << endl;
    cout << m.get_id() << endl;
    cout << m.get_name() << endl;
    cout << endl;

    // 最後回傳 0 給作業系統
    return 0;
}

/* 《程式語言教學誌》的範例程式
   http://kaiching.org/
   檔名：exercise1206.cxx
   編譯：g++ exercise1206.cxx
   執行：./a.out
   功能：C++入門指南單元十二的練習
   作者：張凱慶 */
