// 引入標準程式庫中相關的輸入、輸出程式
#include <iostream>
// 引入標準程式庫中相關的型態支援程式
#include <limits>

// cout 為 std 中的輸出物件
using std::cout;
// endl 為 std 中的斷行符號
using std::endl;
// numeric_limits 為 std 中存放極限值的樣板類別
using std::numeric_limits;

int main(void) {
    // 印出 short 的範圍
    cout << numeric_limits<short>::min() << ", ";
    cout << numeric_limits<short>::max() << endl;

    // 印出 int 的範圍
    cout << numeric_limits<int>::min() << ", ";
    cout << numeric_limits<int>::max() << endl;

    // 印出 long 的範圍
    cout << numeric_limits<long>::min() << ", ";
    cout << numeric_limits<long>::max() << endl;

    // 印出 long long 的範圍
    cout << numeric_limits<long long>::min() << ", ";
    cout << numeric_limits<long long>::max() << endl;

    // 印出 unsigned long long 的範圍
    cout << numeric_limits<unsigned long long>::min() << ", ";
    cout << numeric_limits<unsigned long long>::max() << endl;

    // 印出 float 的範圍
    cout << numeric_limits<float>::min() << ", ";
    cout << numeric_limits<float>::max() << endl;

    // 印出 double 的範圍
    cout << numeric_limits<double>::min() << ", ";
    cout << numeric_limits<double>::max() << endl;

    // 最後回傳 0 給作業系統
    return 0;
}

/* 《程式語言教學誌》的範例程式
   http://kaiching.org/
   檔名：exercise1406.cxx
   編譯：g++ exercise1406.cxx
   執行：./a.out
   功能：C++入門指南單元十四的練習
   作者：張凱慶 */
