// 引入標準程式庫中相關的輸入、輸出程式
#include <iostream>
// 引入標準程式庫中相關的型態資訊程式
#include <typeinfo>

// cout 為 std 中的輸出物件
using std::cout;
// endl 為 std 中的斷行符號
using std::endl;

int main(void) {
    // 宣告整數與浮點數變數
    float a = 1.0;
    double b = 2.0;
    long c = 3;

    // 印出 float 與 double 混合計算後的型態
    cout << typeid(a + b).name() << endl;
    // 印出 float 與 long 混合計算後的型態
    cout << typeid(a + c).name() << endl;
    // 印出 double 與 long 混合計算後的型態
    cout << typeid(b + c).name() << endl;

    // 最後回傳 0 給作業系統
    return 0;
}

/* 《程式語言教學誌》的範例程式
   http://kaiching.org/
   檔名：exercise1408.cxx
   編譯：g++ exercise1408.cxx
   執行：./a.out
   功能：C++入門指南單元十四的練習
   作者：張凱慶 */
