// 引入標準程式庫中相關的輸入、輸出程式
#include <iostream>
// 引入標準程式庫中的 vector
#include <vector>

// cout 為 std 中的輸出物件
using std::cout;
// endl 為 std 中的斷行符號
using std::endl;
// vector 為 std 中的集合體型態
using std::vector;

int main(void) {
    // 宣告建立整數 vector
    vector<int> v(3, 10);

    // 在開頭插入 30
    v.insert(v.begin(), 30);
    for (int i: v) {
        cout << i << ' ';
    }
    cout << endl;

    // 在結尾插入 40
    v.insert(v.end(), 40);
    for (int i: v) {
        cout << i << ' ';
    }
    cout << endl;

    // 在索引值 3 插入 50
    v.insert(v.begin() + 2, 50);
    for (int i: v) {
        cout << i << ' ';
    }
    cout << endl;

    // 最後回傳 0 給作業系統
    return 0;
}

/* 《程式語言教學誌》的範例程式
   http://kaiching.org/
   檔名：exercise1605.cxx
   編譯：g++ exercise1605.cxx -std=c++11
   執行：./a.out
   功能：C++入門指南單元十六的練習
   作者：張凱慶 */
