// 引入標準程式庫中相關的輸入、輸出程式
#include <iostream>
// 引入標準程式庫中的擬隨機數相關程式
#include <random>

// cout 為 std 中的輸出物件
using std::cout;
// endl 為 std 中的斷行符號
using std::endl;
// random_device 為 std 中的隨機設備
using std::random_device;
// default_random_engine 為 std 中的擬隨機數產生器
using std::default_random_engine;
// uniform_int_distribution 為 std 中的機率分佈
using std::uniform_int_distribution;

int main(void) {
    // 建立隨機設備變數
    random_device r;
    // 建立擬隨機數產生器變數
    default_random_engine e(r());
    // 建立隨機分佈變數
    uniform_int_distribution<default_random_engine::result_type> n(0, 99);

    // 取得擬隨機數
    for (int i = 0; i < 10; i++) {
        cout << n(r) << ", ";
    }
    cout << endl;

    // 最後回傳 0 給作業系統
    return 0;
}

/* 《程式語言教學誌》的範例程式
   http://kaiching.org/
   檔名：exercise1607.cxx
   編譯：g++ exercise1607.cxx
   執行：./a.out
   功能：C++入門指南單元十六的練習
   作者：張凱慶 */
