// 引入標準程式庫中相關的輸入、輸出程式
#include <iostream>
// 引入標準程式庫中相關的時間處理程式
#include <chrono>
// 引入標準程式庫中相關的並行計算程式
#include <thread>

// cout 為 std 中的輸出物件
using std::cout;
// endl 為 std 中的斷行符號
using std::endl;
// sleep_until 為 std 中的暫停函數
using std::this_thread::sleep_until;
// system_clock 為 std 中的時間處理型態
using std::chrono::system_clock;
// seconds 為 std 中的計時函數
using std::chrono::seconds;

int main(void) {
    // 顯示起始訊息
    cout << "開始計時5秒...." << endl;
    // 計時五秒
    for (int i = 5; i >= 1; i--) {
        cout << i << endl;
        sleep_until(system_clock::now() + seconds(1));
    }
    // 顯示結束訊息
    cout << "計時結束" << endl;

    // 最後回傳 0 給作業系統
    return 0;
}

/* 《程式語言教學誌》的範例程式
   http://kaiching.org/
   檔名：exercise1809.cxx
   編譯：g++ exercise1809.cxx -std=c++11
   執行：./a.out
   功能：C++入門指南單元十八的練習
   作者：張凱慶 */
