// 引入標準程式庫中相關的輸入、輸出程式
#include <iostream>
// 引入標準程式庫中的 priority_queue
#include <queue>

// cout 為 std 中的輸出物件
using std::cout;
// endl 為 std 中的斷行符號
using std::endl;
// priority_queue 為 std 中的集合體型態
using std::priority_queue;

int main(void) {
    // 宣告建立整數 priority_queue
    priority_queue<int> q;

    // 在 priority_queue 插入元素
    q.push(13);
    q.push(25);
    q.push(14);
    q.push(26);

    // 利用迴圈印出 priority_queue 元素
    while(!q.empty()) {
        cout << q.top() << ' ';
        q.pop();
        cout << endl;
    }

    // 最後回傳 0 給作業系統
    return 0;
}

/* 《程式語言教學誌》的範例程式
   http://kaiching.org/
   檔名：exercise2104.cxx
   編譯：g++ exercise2104.cxx
   執行：./a.out
   功能：C++入門指南單元二十一的練習
   作者：張凱慶 */
