#ifndef GUESS_H
#define GUESS_H

// 從標準程式庫中引入 string
#include <string>

// 使用 std 中的 string 名稱
using std::string;
using std::to_string;

// 猜數字遊戲類別
class Guess {
public:
    // 建構函數
    Guess(int p = 4);
    // setter
    void SetMemberVariables(int d);
    // getter
    int GetDigit();
    string GetAnswer();
    string GetAB();
    int GetTimes();
    // 將猜測次數加一
    void AddTimes();
    // 計算 A 、 B 值
    void ABCounter(string guess);
    // 尋找是否有重複數字
    bool FindNumber(string guess);
    // 進行遊戲的相關檢測工作
    bool Test(string guess);

private:
    // 答案字串
    string answer;
    // A 、 B 值
    int A;
    int B;
    // 猜測次數
    int times;
    // 猜測數字長度
    int digit;
};

/*《程式語言教學誌》的範例程式
   http://kaiching.org/
   檔名：guess.h
   功能：猜數字遊戲的標頭檔
   作者：張凱慶 */


#endif // GUESS_H
