#ifndef GUESSCONTROLLER_H
#define GUESSCONTROLLER_H

#include <QObject>
#include <QString>
#include <qqml.h>

// 引入 Guess 類別的標頭檔
#include "guess.h"

class GuessController : public QObject
{
    Q_OBJECT
    Q_PROPERTY(QString userInput READ userInput WRITE setUserInput NOTIFY userInputChanged)
    QML_ELEMENT

public:
    GuessController(QObject *parent = nullptr);

    QString userInput();
    void setUserInput(const QString &userInput);

    QString s2q(const string &);
    string q2s(const QString &);

    Q_INVOKABLE void setGuessObject();
    Q_INVOKABLE QString getGuessObject();
    Q_INVOKABLE bool test();
    Q_INVOKABLE bool findNumber();
    Q_INVOKABLE QString getAB();
    Q_INVOKABLE QString getTimes();

signals:
    void userInputChanged();

private:
    QString m_userInput;
    Guess *guessObject;
};

#endif // GUESSCONTROLLER_H
