import QtQuick
import QtQuick.Controls

Window {
    width: 400
    height: 200
    title: qsTr("選單分隔線測試")
    visible: true

    // 設定選單列
    MenuBar {
        Menu {
            title: qsTr("功能")
            MenuItem {
                text: qsTr("改變")
                onTriggered: button.text = "改變"
            }
            MenuSeparator {
                padding: 6
                contentItem: Rectangle {
                    implicitWidth: 10
                    implicitHeight: 1
                    color: "red"
                }
            }
            MenuItem {
                text: qsTr("關閉")
                onTriggered: Qt.quit();
            }
        }
    }

    // 按鈕視窗元件
    Button {
        id: button
        text: qsTr("按鈕")
        anchors.centerIn: parent

        onClicked: {
            button.text = "按鈕"
        }
    }
}

/* 《程式語言教學誌》的範例程式
   http://kaiching.org/
   檔名：main.qml
   功能：示範 MenuSeparator 型態
   作者：張凱慶 */
