// 引入標準程式庫中時間日期的相關程式
#include <ctime>
// 引入標準程式庫中相關的輸入、輸出程式
#include <iostream>
// 引入標準程式庫中的 array
#include <array>
// 引入標準程式庫中的 vector
#include <vector>

// cout 為 std 中的輸出物件
using std::cout;
// endl 為 std 中的斷行符號
using std::endl;
// array 為 std 中的陣列型態
using std::array;
// vector 為 std 中的集合體型態
using std::vector;

int main() {
    // 計算陣列處理時間
    time_t t1 = time(NULL);
    long i = 0;
    array<long, 1000000> a;
    for (int j: a) {
        j = i++;
        cout << j << ", ";
    }
    cout << endl;

    time_t t2 = time(NULL);

    // 計算 vector 處理時間
    time_t t3 = time(NULL);
    vector<long> v;
    for (int k = 0; k < 1000000; k++) {
        v.insert(v.end(), k);
        cout << v[k] << ", ";
    }
    cout << endl;

    time_t t4 = time(NULL);

    // 顯示處理時間
    cout << endl << endl;
    cout << "array: " << t2 - t1 << endl;
    cout << "vector: " << t4 - t2 << endl;

    return 0;
}

/* 《程式語言教學誌》的範例程式
   http://kaiching.org/
   檔名：time_test.cxx
   功能：示範利用標準程式庫比較 array 與 vector 執行時間
   作者：張凱慶 */
